function mask = createOptimizerMask(params, MGPopts, optInputs)
%
%
%

idx = 0;
opposite_mask = [];

% add parameters for each kernel
for n = 1:length(MGPopts)
    szUs = MGPopts{n}.Ns * MGPopts{n}.qs;
    if (optInputs(n) == 1)
        opposite_mask = [opposite_mask, idx + [1:szUs]];
    end
    idx = idx + szUs;

    numParams = MGPopts{n}.Nhps + MGPopts{n}.Nphps
    if (numParams > 0)
        opposite_mask = [opposite_mask, idx + [1:numParams]];
        idx = idx + numParams;
    end
end

% add theta (overall kernel scale) and beta (process noise) parameters
opposite_mask = [opposite_mask, idx + [1:2]];

mask = setdiff(1:length(params), opposite_mask); 